"use strict";function Stream(a,b){if(a instanceof Stream){this.enc=a.enc;this.pos=a.pos;}else{this.enc=a;this.pos=b;}}Stream.prototype.ellipsis="\u2026";Stream.prototype.get=function(a){if(a===undefined)a=this.pos++;if(a>=this.enc.length)throw 'Requesting byte offset '+a+' on a stream of length '+this.enc.length;return this.enc[a];};Stream.prototype.hexDigits="0123456789ABCDEF";Stream.prototype.hexByte=function(a){return this.hexDigits.charAt((a>>4)&0xF)+this.hexDigits.charAt(a&0xF);};Stream.prototype.hexDump=function(a,b,c){var d="";for(var e=a;e<b;++e){d+=this.hexByte(this.get(e));if(c!==true)switch(e&0xF){case 0x7:d+="  ";break;case 0xF:d+="\n";break;default:d+=" ";}}return d;};Stream.prototype.parseStringISO=function(a,b){var c="";for(var d=a;d<b;++d)c+=String.fromCharCode(this.get(d));return c;};Stream.prototype.parseStringUTF=function(a,b){var c="",d=0;for(var e=a;e<b;){d=this.get(e++);if(d<128)c+=String.fromCharCode(d);else if((d>191)&&(d<224))c+=String.fromCharCode(((d&0x1F)<<6)|(this.get(e++)&0x3F));else c+=String.fromCharCode(((d&0x0F)<<12)|((this.get(e++)&0x3F)<<6)|(this.get(e++)&0x3F));}return c;};Stream.prototype.reTime=/^((?:1[89]|2\d)?\d\d)(0[1-9]|1[0-2])(0[1-9]|[12]\d|3[01])([01]\d|2[0-3])(?:([0-5]\d)(?:([0-5]\d)(?:[.,](\d{1,3}))?)?)?(Z|[-+](?:[0]\d|1[0-2])([0-5]\d)?)?$/;Stream.prototype.parseTime=function(a,b){var c=this.parseStringISO(a,b);var d=this.reTime.exec(c);if(!d)return "Unrecognized time: "+c;c=d[1]+"-"+d[2]+"-"+d[3]+" "+d[4];if(d[5]){c+=":"+d[5];if(d[6]){c+=":"+d[6];if(d[7])c+="."+d[7];}}if(d[8]){c+=" UTC";if(d[8]!='Z'){c+=d[8];if(d[9])c+=":"+d[9];}}return c;};Stream.prototype.parseInteger=function(a,b){var c=b-a;if(c>4){c<<=3;var d=this.get(a);if(d===0)c-=8;else while(d<128){d<<=1;--c;}return "("+c+" bit)";}var e=0;for(var f=a;f<b;++f)e=(e<<8)|this.get(f);return e;};Stream.prototype.parseBitString=function(a,b){var c=this.get(a);var d=((b-a-1)<<3)-c;var e="("+d+" bit)";if(d<=20){var f=c;e+=" ";for(var g=b-1;g>a;--g){var h=this.get(g);for(var i=f;i<8;++i)e+=(h>>i)&1?"1":"0";f=0;}}return e;};Stream.prototype.parseOctetString=function(a,b){var c=b-a;var d="("+c+" byte) ";if(c>20)b=a+20;for(var e=a;e<b;++e)d+=this.hexByte(this.get(e));if(c>20)d+=Stream.ellipsis;return d;};Stream.prototype.parseOID=function(a,b){var c='',d=0,e=0;for(var f=a;f<b;++f){var g=this.get(f);d=(d<<7)|(g&0x7F);e+=7;if(!(g&0x80)){if(c===''){var h=d<80?d<40?0:1:2;c=h+"."+(d-h*40);}else c+="."+((e>=31)?"bigint":d);d=e=0;}}return c;};function ASN11(a,b,c,d,e){this.stream=a;this.header=b;this.length=c;this.tag=d;this.sub=e;}ASN11.prototype.typeName=function(){if(this.tag===undefined)return "unknown";var a=this.tag>>6;var b=(this.tag>>5)&1;var c=this.tag&0x1F;switch(a){case 0:switch(c){case 0x00:return "EOC";case 0x01:return "BOOLEAN";case 0x02:return "INTEGER";case 0x03:return "BIT_STRING";case 0x04:return "OCTET_STRING";case 0x05:return "NULL";case 0x06:return "OBJECT_IDENTIFIER";case 0x07:return "ObjectDescriptor";case 0x08:return "EXTERNAL";case 0x09:return "REAL";case 0x0A:return "ENUMERATED";case 0x0B:return "EMBEDDED_PDV";case 0x0C:return "UTF8String";case 0x10:return "SEQUENCE";case 0x11:return "SET";case 0x12:return "NumericString";case 0x13:return "PrintableString";case 0x14:return "TeletexString";case 0x15:return "VideotexString";case 0x16:return "IA5String";case 0x17:return "UTCTime";case 0x18:return "GeneralizedTime";case 0x19:return "GraphicString";case 0x1A:return "VisibleString";case 0x1B:return "GeneralString";case 0x1C:return "UniversalString";case 0x1E:return "BMPString";default:return "Universal_"+c.toString(16);}case 1:return "Application_"+c.toString(16);case 2:return "["+c+"]";case 3:return "Private_"+c.toString(16);}};ASN11.prototype.reSeemsASCII=/^[ -~]+$/;ASN11.prototype.content=function(){if(this.tag===undefined)return null;var a=this.tag>>6,b=this.tag&0x1F,c=this.posContent(),d=Math.abs(this.length);if(a!==0){if(this.sub!==null)return "("+this.sub.length+" elem)";var e=this.stream.parseStringISO(c,c+d);if(this.reSeemsASCII.test(e))return e.substring(0,40)+((e.length>40)?this.stream.ellipsis:"");else return this.stream.parseOctetString(c,c+d);}switch(b){case 0x01:return(this.stream.get(c)===0)?"false":"true";case 0x02:return this.stream.parseInteger(c,c+d);case 0x03:return this.sub?"("+this.sub.length+" elem)":this.stream.parseBitString(c,c+d);case 0x04:return this.sub?"("+this.sub.length+" elem)":this.stream.parseOctetString(c,c+d);case 0x06:return this.stream.parseOID(c,c+d);case 0x10:case 0x11:return "("+this.sub.length+" elem)";case 0x0C:return this.stream.parseStringUTF(c,c+d);case 0x12:case 0x13:case 0x14:case 0x15:case 0x16:case 0x1A:return this.stream.parseStringISO(c,c+d);case 0x17:case 0x18:return this.stream.parseTime(c,c+d);}return null;};ASN11.prototype.toString=function(){return this.typeName()+"@"+this.stream.pos+"[header:"+this.header+",length:"+this.length+",sub:"+((this.sub===null)?'null':this.sub.length)+"]";};ASN11.prototype.print=function(a){if(a===undefined)a='';document.writeln(a+this);if(this.sub!==null){a+='  ';for(var b=0,c=this.sub.length;b<c;++b)this.sub[b].print(a);}};ASN11.prototype.toPrettyString=function(a){if(a===undefined)a='';var b=a+this.typeName()+" @"+this.stream.pos;if(this.length>=0)b+="+";b+=this.length;if(this.tag&0x20)b+=" (constructed)";else if(((this.tag==0x03)||(this.tag==0x04))&&(this.sub!==null))b+=" (encapsulates)";b+="\n";if(this.sub!==null){a+='  ';for(var c=0,d=this.sub.length;c<d;++c)b+=this.sub[c].toPrettyString(a);}return b;};ASN11.prototype.getCSRPubKey=function(){var a=this.getCSRPubKeyAddress();var b=this.stream.hexDump(a.modStart,a.modEnd);var c=this.stream.hexDump(a.expStart,a.expEnd);return{'modulus':b,'exponent':c};};ASN11.prototype.getCSRPubKeyAddress=function(a){if(a===undefined)a={'modStart':0,'modEnd':0,'expStart':0,'expEnd':0};if(((this.tag==0x03)||(this.tag==0x04))&&(this.sub!==null)){var b=this.sub[0].sub[0];a.modStart=b.stream.pos+Math.abs(b.header);a.modEnd=a.modStart+Math.abs(b.length);b=this.sub[0].sub[1];a.expStart=b.stream.pos+Math.abs(b.header);a.expEnd=a.expStart+Math.abs(b.length);return a;}else if(this.sub!==null)for(var c=0,d=this.sub.length;c<d;++c)this.sub[c].getCSRPubKeyAddress(a);return a;};ASN11.prototype.toDOM=function(){var a=document.createElement("div");a.className="node";a.asn1=this;var b=document.createElement("div");b.className="head";var c=this.typeName().replace(/_/g," ");b.innerHTML=c;var d=this.content();if(d!==null){d=String(d).replace(/</g,"&lt;");var e=document.createElement("span");e.className="preview";e.innerHTML=d;b.appendChild(e);}a.appendChild(b);this.node=a;this.head=b;var f=document.createElement("div");f.className="value";c="Offset: "+this.stream.pos+"<br/>";c+="Length: "+this.header+"+";if(this.length>=0)c+=this.length;else c+=(-this.length)+" (undefined)";if(this.tag&0x20)c+="<br/>(constructed)";else if(((this.tag==0x03)||(this.tag==0x04))&&(this.sub!==null))c+="<br/>(encapsulates)";if(d!==null){c+="<br/>Value:<br/><b>"+d+"</b>";if((typeof oids==='object')&&(this.tag==0x06)){var g=oids[d];if(g){if(g.d)c+="<br/>"+g.d;if(g.c)c+="<br/>"+g.c;if(g.w)c+="<br/>(warning!)";}}}f.innerHTML=c;a.appendChild(f);var h=document.createElement("div");h.className="sub";if(this.sub!==null)for(var i=0,j=this.sub.length;i<j;++i)h.appendChild(this.sub[i].toDOM());a.appendChild(h);b.switchNode=a;b.onclick=function(){var a=this.switchNode;a.className=(a.className=="node collapsed")?"node":"node collapsed";};return a;};ASN11.prototype.posStart=function(){return this.stream.pos;};ASN11.prototype.posContent=function(){return this.stream.pos+this.header;};ASN11.prototype.posEnd=function(){return this.stream.pos+this.header+Math.abs(this.length);};ASN11.prototype.fakeHover=function(a){this.node.className+=" hover";if(a)this.head.className+=" hover";};ASN11.prototype.fakeOut=function(a){var b=/ ?hover/;this.node.className=this.node.className.replace(b,"");if(a)this.head.className=this.head.className.replace(b,"");};ASN11.prototype.toHexDOM_sub=function(a,b,c,d,e){if(d>=e)return;var f=document.createElement("span");f.className=b;f.appendChild(document.createTextNode(c.hexDump(d,e)));a.appendChild(f);};ASN11.prototype.toHexDOM=function(a){var b=document.createElement("span");b.className='hex';if(a===undefined)a=b;this.head.hexNode=b;this.head.onmouseover=function(){this.hexNode.className="hexCurrent";};this.head.onmouseout=function(){this.hexNode.className="hex";};b.asn1=this;b.onmouseover=function(){var b=!a.selected;if(b){a.selected=this.asn1;this.className="hexCurrent";}this.asn1.fakeHover(b);};b.onmouseout=function(){var b=(a.selected==this.asn1);this.asn1.fakeOut(b);if(b){a.selected=null;this.className="hex";}};this.toHexDOM_sub(b,"tag",this.stream,this.posStart(),this.posStart()+1);this.toHexDOM_sub(b,(this.length>=0)?"dlen":"ulen",this.stream,this.posStart()+1,this.posContent());if(this.sub===null)b.appendChild(document.createTextNode(this.stream.hexDump(this.posContent(),this.posEnd())));else if(this.sub.length>0){var c=this.sub[0];var d=this.sub[this.sub.length-1];this.toHexDOM_sub(b,"intro",this.stream,this.posContent(),c.posStart());for(var e=0,f=this.sub.length;e<f;++e)b.appendChild(this.sub[e].toHexDOM(a));this.toHexDOM_sub(b,"outro",this.stream,d.posEnd(),this.posEnd());}return b;};ASN11.prototype.toHexString=function(a){return this.stream.hexDump(this.posStart(),this.posEnd(),true);};ASN11.decodeLength=function(a){var b=a.get();var c=b&0x7F;if(c==b)return c;if(c>3)throw "Length over 24 bits not supported at position "+(a.pos-1);if(c===0)return -1;b=0;for(var d=0;d<c;++d)b=(b<<8)|a.get();return b;};ASN11.hasContent=function(a,b,c){if(a&0x20)return true;if((a<0x03)||(a>0x04))return false;var d=new Stream(c);if(a==0x03)d.get();var e=d.get();if((e>>6)&0x01)return false;try{var f=ASN11.decodeLength(d);return((d.pos-c.pos)+f==b);}catch(g){return false;}};ASN11.decode=function(a){if(!(a instanceof Stream))a=new Stream(a,0);var b=new Stream(a);var c=a.get();var d=ASN11.decodeLength(a);var e=a.pos-b.pos;var f=null;if(ASN11.hasContent(c,d,a)){var g=a.pos;if(c==0x03)a.get();f=[];if(d>=0){var h=g+d;while(a.pos<h)f[f.length]=ASN11.decode(a);if(a.pos!=h)throw "Content size is not correct for container starting at offset "+g;}else try{for(;;){var i=ASN11.decode(a);if(i.tag===0)break;f[f.length]=i;}d=g-a.pos;}catch(j){throw "Exception while decoding undefined length content: "+j;}}else a.pos+=d;return new ASN11(b,e,d,c,f);};ASN11.test=function(){var a=[{value:[0x27],expected:0x27},{value:[0x81,0xC9],expected:0xC9},{value:[0x83,0xFE,0xDC,0xBA],expected:0xFEDCBA}];for(var b=0,c=a.length;b<c;++b){var d=0;var e=new Stream(a[b].value,0);var f=ASN11.decodeLength(e);if(f!=a[b].expected)document.write("In test["+b+"] expected "+a[b].expected+" got "+f+"\n");}};